#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define DMAX 1000
#define MYOFF 15
#define IMAX 20
 XColor gray[256];
 Display    *dpy;
 Window      win;
 XWindowAttributes attrib;
 GC          mygc;
 XSizeHints  xsh;
 Colormap cmap;
 Pixmap mypixmap;
 int scr,depth,root,inv;
 char *host;
/*---------------------------------------------------------------------------------------*/
/* Nacita obrazok zo suboru PIC do bytoveho pola ,ktoremu alokuje pamat .                */
/*---------------------------------------------------------------------------------------*/
loadpic(dat,vx,vy,subor)
unsigned char  *dat[];
int     *vx,*vy;
char    *subor;
{unsigned char buf[2048];
 long fp1,nread;
 int a,b,fd1;
 fd1=open(subor,0);
 if(fd1 == -1)
   {perror("chyba vst. dat. suboru");
	exit(1);
	}
 fp1=lseek(fd1,0L,0);
 nread=read(fd1,buf,4);
 *vx=buf[0]+256*buf[1];
 *vy=buf[2]+256*buf[3];
 fp1=lseek(fd1,4L,0);
 for(a=0;a<*vy;a++)
   {if((dat[a] = (unsigned char *)calloc(*vx,1))==0)
	  {perror("Chyba pri alokacii pamati");
	   exit(0);}
	if((nread=read(fd1,dat[a],*vx))!= *vx)
	  {perror("Cybny format PIC suboru");
	   exit(0);};
	}
 close(fd1);
}
/*---------------------------------------------------------------------------------------*/
/* Zapise obrazok do suboru PIC                                                          */
/*---------------------------------------------------------------------------------------*/
 savepic(unsigned char *dat[],int vx,int vy,int zx,int zy,int sx,int sy,float mx,float my)
    {  long   nwrite,fp2;
       int fd2,i,j,sizx,sizy ;
       char vystsubor[80];
       unsigned char buf[DMAX];
       char cordtype;
       printf("Enter file name:\n");
       scanf("%s",vystsubor);
       printf("Save Physical or Magnified image? (p/m)\n");
       cordtype=getc(stdin);cordtype=getc(stdin);
       if((cordtype=='p')||(cordtype=='P'))
         { mx=1.0;my=1.0 ;}
       fd2=creat(vystsubor,0644);
       close(fd2);fd2=open(vystsubor,1);
       if(fd2 == -1){ printf("Error creating output file %s",vystsubor);}
       else
         { sizx=(int)(mx*sx+0.5);sizy=(int)(my*sy+0.5);
          buf[1]=sizx/256;buf[0]=sizx%256;buf[3]=sizy/256;buf[2]=sizy%256;
          fp2=lseek(fd2,0L,0);nwrite=write(fd2,buf,4);      
          for(i=0;i<sizy;i++)
              { for(j=0;j<sizx;j++)
                   buf[j]= *(dat[(int)(1.0*i/my)+zy]+(int)(1.0*j/mx)+zx);
                nwrite=write(fd2,buf,sizx);
                }    
          close(fd2); 
          if((cordtype=='p')||(cordtype=='P'))
            { printf("Physical data saved (%dx%d pixels)\n",sizx,sizy);}
          else  
            { printf("Magnified data saved (%dx%d pixels)\n",sizx,sizy);}
          };
     }
/*-----------------------------------------------------------------*/
/* Prepise nacitane data do Image struktury podla aktualnej mierky */
/* Alokuje pamat a pripadne robi dithering (black/white monitory)  */
/*-----------------------------------------------------------------*/
pic_to_image(dat,vx,vy,imgzx,imgzy,imgsx,imgsy,magx,magy,pimage)
 unsigned char    *dat[];
	int     vx,vy;
	XImage  **pimage;
	float     magx,magy;
{
 int    bpr,dathod;
 XImage **hhmage;
 float  i,j;
 int 	format;
 int  *pole[DMAX];

 /* ----------- alokovanie podla typu displaya -------------------*/
 *pimage =XCreateImage(dpy,DefaultVisual(dpy,scr),depth,
			ZPixmap,0,0,(int)(magx*imgsx+0.5),(int)(magy*imgsy+0.5),
			16,0
			);
 if ( *pimage == 0)
   {perror("chyba  struktury v programe");exit(0);}
 bpr = (*pimage)->bytes_per_line;
 (*pimage)->data = (char *) calloc((int)(magy*(imgsy+1)),bpr ) ;
 if((*pimage)->data== 0)
   {printf("chyba pri alokacii");
	exit(1);}
 
 for(i=0;i<(int)(magy*imgsy+0.5);i++)
   for(j=0;j<(int)(magx*imgsx+0.5);j++)
      { dathod= *(dat[(int)(1.0*i/magy)+imgzy]+(int)(1.0*j/magx)+imgzx);
        XPutPixel(*pimage,j,i,gray[dathod/2].pixel);
        }
 } 
/*--------------------------------------------------------------------------------*/
/* Otvori display na zelanom pocitaci , pri Grayscale alebo Color monitoroch sa   */
/* snazi alokovat 128 farieb (ako stupne sedi)                                    */
/*--------------------------------------------------------------------------------*/
rob_display_a_farby(host)
char *host;
{int chyby,cell,intensity;
 if ((dpy = XOpenDisplay(host)) == NULL)
   {printf("nemozem otvorit display:%s\n",host);
	exit(1);
	}
 scr = DefaultScreen(dpy);
 depth = DefaultDepth  (dpy,DefaultScreen(dpy));
 if(depth>=8)
   {cmap = DefaultColormap(dpy, DefaultScreen(dpy));
	chyby=0;
	for(cell=0;cell < 128;cell++)
	  { intensity = cell * 65536L / 128L;
		gray[cell].red=gray[cell].green = gray[cell].blue = intensity;
		if(!XAllocColor(dpy,cmap,&(gray[cell])))chyby++;
		}
	if(chyby)printf("Neda sa alokovat %d farieb\n",chyby);
	 }
 }
/*--------------------------------------------------------------------------------*/
/* Kresli Xorovany stvorec                                                        */
/*--------------------------------------------------------------------------------*/
stvorec(int x1,int y1,int x2,int y2)
{  if((x1!=x2)||(y1!=y2))
     {	XSetFunction(dpy, mygc, GXequiv);
        XDrawLine(dpy,win,mygc,x1,y1,x2,y1);
        XDrawLine(dpy,win,mygc,x1,y1,x1,y2);
        XDrawLine(dpy,win,mygc,x1,y2,x2,y2);
        XDrawLine(dpy,win,mygc,x2,y1,x2,y2);   
        XSetFunction(dpy, mygc, GXcopy);
        }
}                         

/*--------------------------------------------------------------------------------*/
/* Vytvara graficky kontext pre zvolene okno                                      */
/*--------------------------------------------------------------------------------*/
do_GC()
{  mygc = XCreateGC(dpy,win,0,0);
   XSetBackground(dpy,mygc,WhitePixel(dpy,scr));
   XSetForeground(dpy,mygc,BlackPixel(dpy,scr));
   XSelectInput(dpy,win,ButtonPressMask|ButtonReleaseMask|PointerMotionMask|
			  KeyPressMask|EnterWindowMask|LeaveWindowMask|ExposureMask);
   XMapRaised(dpy,win);
  }

/*--------------------------------------------------------------------------------*/
/* Hlavna procedura programu                                                      */
/* najprv inicializuje potrebne struktury a potom vchadza do slucky , v ktorej na */
/* zaklade X-udalosti od uzivatela meni velkost okna,vypisuje data, pripadne konci*/
/*--------------------------------------------------------------------------------*/
main(argc,argv)
	int argc;
	char **argv;
{ int vx,vy;
  unsigned char *dat[DMAX];
  XImage *image;
  int leave,wstate,done,i;
  int imgvx,imgvy;
  int imgpx[IMAX],imgpy[IMAX],imgsx[IMAX],imgsy[IMAX];
  float imgmagx[IMAX];
  float imgmagy[IMAX];
  float magx,magy,tmpmagx,tmpmagy,tmpmag;
  int datpos,tmppos;
  int dxpos,dypos;
  int winx,winy;
  int oznac=0;
  int oznacx1,oznacy1,oznacx2,oznacy2,otmp;
  char obrazok[255];
  char info[30],text[10],znak;
  XEvent      event;
  KeySym      mykey;

  if(argc>1)
	{strcpy(obrazok,argv[1]);
	 if(argc>3){host=argv[1];} else host = (char *) getenv("DISPLAY");
	 }
  else
	 {printf("******************************************************************\n");
	  printf("*  xs1.0 ,   PIC image viewer (1998 R.Vargic)                    *\n");
	  printf("*----------------------------------------------------------------*\n");
	  printf("* Usage:     +     - zoom in  (2x)                               *\n");
          printf("*            -     - zoom out (2x)                               *\n");
          printf("*            SPACE - original size                               *\n");
          printf("*            ESC   - end                                         *\n");
          printf("*            s     - save data (interactive in shell)            *\n");
          printf("*            mouse left button  - select & magnify region        *\n");
	  printf("*            mouse right button - undo                           *\n");
	  printf("*----------------------------------------------------------------*\n");
	  printf("* To start:  xs <myfile.pic> [display]                           *\n");
	  printf("******************************************************************\n");
	  printf("Input file:");
	  scanf("%s",obrazok);
	};
  rob_display_a_farby(host);
  datpos=0;
  loadpic(dat,&imgvx,&imgvy,obrazok);
  for(i=0;i<IMAX;i++)
    {imgpx[i]=0;imgpy[i]=0;imgsx[i]=imgvx;imgsy[i]=imgvy;imgmagx[i]=1.0;  imgmagy[i]=1.0; }
  done=0; wstate=0;
  do{  pic_to_image(dat,imgvx,imgvy,imgpx[datpos],imgpy[datpos],
                    imgsx[datpos],imgsy[datpos],imgmagx[datpos],imgmagy[datpos],&image);
       winx =(int)(imgmagx[datpos]*imgsx[datpos]);
       winy =(int)(imgmagy[datpos]*imgsy[datpos]+MYOFF);
       xsh.x = 0;xsh.y = 0;
       xsh.flags=PPosition | PSize;
       xsh.width=winx;
       xsh.height=winy;
       win = XCreateSimpleWindow(dpy,DefaultRootWindow(dpy),
                                 xsh.x,xsh.y,xsh.width,xsh.height,50,
	                         BlackPixel(dpy,scr),WhitePixel(dpy,scr)
       	                         );
       XSetStandardProperties(dpy,win,obrazok,obrazok,None,argv,argc,&xsh);
       do_GC();
       leave=0;
       while(leave==0)
	 {XNextEvent(dpy,&event);
          switch(event.type)
	   {case Expose:while(XCheckTypedEvent(dpy,Expose,&event));
                        XGetWindowAttributes(dpy,win,&attrib);
                        if((attrib.width!=winx)||(attrib.height!=winy))
                            {free(image->data);
                             if(attrib.width!=104)tmppos=(datpos+1)%IMAX;
                             imgpx[tmppos]=imgpx[datpos];imgpy[tmppos]=imgpy[datpos];
                             imgsx[tmppos]=imgsx[datpos];imgsy[tmppos]=imgsy[datpos];
                             imgmagx[tmppos]=(float)attrib.width/imgsx[tmppos];
                             imgmagy[tmppos]=(float)(attrib.height-MYOFF)/imgsy[tmppos];
                             datpos=tmppos;
                             pic_to_image(dat,imgvx,imgvy,imgpx[datpos],imgpy[datpos],
                             		  imgsx[datpos],imgsy[datpos],
                             		  imgmagx[datpos],imgmagy[datpos],&image);
                             winx=attrib.width;
                             winy=attrib.height;
                        }
                        XPutImage(dpy,win,mygc,image,0,0,0,
                        	  MYOFF,winx,winy-MYOFF);
                        XFlush(dpy);
			break;
		case EnterNotify:wstate=1;break;
		case LeaveNotify:wstate=0;break;
                case ButtonRelease:
		        if(event.xbutton.button==1)
			  { oznac=0;
			    stvorec(oznacx1,oznacy1,oznacx2,oznacy2);
                            if((oznacx1==oznacx2)&&(oznacy1==oznacy2))
                              { ;
                                }
                            else
                              { oznacy1-=MYOFF;oznacy2-=MYOFF;
                                if(oznacx1>oznacx2) {otmp=oznacx1;oznacx1=oznacx2;oznacx2=otmp;};
                                if(oznacy1>oznacy2) {otmp=oznacy1;oznacy1=oznacy2;oznacy2=otmp;};
                                tmppos=(datpos+1)%IMAX;
                                imgpx[tmppos]=imgpx[datpos]+(int)((float)oznacx1/imgmagx[datpos]);
                                imgpy[tmppos]=imgpy[datpos]+(int)((float)oznacy1/imgmagy[datpos]);
                                imgsx[tmppos]=(int)(((float)oznacx2-oznacx1)/imgmagx[datpos])+1;
                                imgsy[tmppos]=(int)(((float)oznacy2-oznacy1)/imgmagy[datpos])+1;
                                tmpmagx=(float)imgsx[datpos]/imgsx[tmppos];
                                tmpmagy=(float)imgsy[datpos]/imgsy[tmppos];
                                tmpmag= tmpmagx<tmpmagy ? tmpmagx:tmpmagy;
                                imgmagx[tmppos]=imgmagx[datpos]*tmpmag;
                                imgmagy[tmppos]=imgmagy[datpos]*tmpmag;
                                leave=1;
                                datpos=tmppos;
                                }
                        }
                        break;
				
		case ButtonPress: 
		        if(event.xbutton.button==3)
			  { datpos=(datpos+IMAX-1)%IMAX;
			    leave=1;
			    }
			if(event.xbutton.button==1)
			  { if((event.xbutton.x<winx)&&
			       (event.xbutton.x>=0) &&
			       (event.xbutton.y<winx) &&
			       (event.xbutton.y>=MYOFF))
			      {  oznac=1;
			         oznacx2=oznacx1=event.xbutton.x;
			         oznacy2=oznacy1=event.xbutton.y;
			         }
			    }
			break;		 
		case MappingNotify:XRefreshKeyboardMapping((XMappingEvent *)&event);
				     break;
				     
		case MotionNotify:	
		     if(oznac)
			  { stvorec(oznacx1,oznacy1,oznacx2,oznacy2);
			    oznacx2=event.xbutton.x;
			    oznacy2=event.xbutton.y;
			    if(oznacx2>=winx)oznacx2=winx-1;
			    if(oznacy2>=winy)oznacy2=winy-1;
			    if(oznacx2<0)oznacx2=0;
			    if(oznacy2<MYOFF)oznacy2=MYOFF;
			    stvorec(oznacx1,oznacy1,oznacx2,oznacy2);
                            
                            sprintf(info,"SELECT: (%03d,%03d)+(%03d,%03d)-->(%03d,%03d)    ",
			            imgpx[datpos]+(int)( (float)oznacx1/imgmagx[datpos]),
			            imgpy[datpos]+(int)( ((float)oznacy1-MYOFF)/imgmagy[datpos]), 
			            (int)( (float)oznacx2/imgmagx[datpos])-
			            (int)( (float)oznacx1/imgmagx[datpos])+1,
			            (int)( ((float)oznacy2-MYOFF)/imgmagy[datpos])- 
			            (int)( ((float)oznacy1-MYOFF)/imgmagy[datpos])+1, 
			            imgpx[datpos]+(int)( (float)oznacx2/imgmagx[datpos]),
			            imgpy[datpos]+(int)( ((float)oznacy2-MYOFF)/imgmagy[datpos]));
                              XDrawImageString(dpy,win,mygc,0,MYOFF-3,
                                               info,strlen(info));
                              XFlush(dpy);
			    }
                     else
                      { if(wstate==1)
		         { dypos=imgpy[datpos]+(int)
		               ( ((float)event.xbutton.y-MYOFF)/imgmagy[datpos]);
                         dxpos=imgpx[datpos]+(int)((float)event.xbutton.x/imgmagx[datpos]);
                         if(dxpos>=0 && dxpos <imgvx && dypos >=0 && dypos<imgvy)
                            { sprintf(info,"X:%03d Y:%03d Z:%03d  P:%03dx%03d(M:%03dx%03d) |%d|",
                              dxpos,dypos,*(dat[dypos]+dxpos),
                              imgsx[datpos],imgsy[datpos],winx,winy-MYOFF,datpos);
                              XDrawImageString(dpy,win,mygc,0,MYOFF-3,
                                               info,strlen(info));
                                             
                              XFlush(dpy);
			      }
			  }
			}
		     break;
		case KeyPress:znak=XLookupString((XKeyEvent *)&event,text,10,&mykey,0);
                              if(znak==1)
                                 {text[0]=tolower(text[0]);
                                  if(text[0]=='-')
                                     {magx=imgmagx[datpos]/2; magy=imgmagy[datpos]/2;leave=1;
                                      }
                                  if(text[0]=='+')
                                     {magx=imgmagx[datpos]*2;magy=imgmagy[datpos]*2;leave=1;
                                      }
                                  if(text[0]==' '){magx=1;magy=1;leave=1;}
                                  if(leave==1)
                                      {if( ((imgsx[datpos]*magx)<=DMAX) &&
                                         ((imgsy[datpos]*magy)<=DMAX)&&
                                         (magx>=1.0/imgsx[datpos])&&
                                         (magy>=1.0/imgsy[datpos]))
                                         { tmppos=(datpos+1)%IMAX;
                                           imgpx[tmppos]=imgpx[datpos];
                                           imgpy[tmppos]=imgpy[datpos];
                                           imgsx[tmppos]=imgsx[datpos];
                                           imgsy[tmppos]=imgsy[datpos];
                                           imgmagx[tmppos]=magx;
                                           imgmagy[tmppos]=magy;
                                           datpos=tmppos;
                                           }
                                       else leave=0; 
                                      }   
                                  if((int)text[0]==27){leave=1;done=1;}
                                  if(text[0]=='s')
                                    savepic(dat,imgvx,imgvy,imgpx[datpos],imgpy[datpos],
                                            imgsx[datpos],imgsy[datpos],
                                            imgmagx[datpos],imgmagy[datpos]);
                                  }                               
                                  break;
             }
           }
	 free(image->data);
	 XFlush(dpy);
	 XFreeGC(dpy,mygc);
	 XDestroyWindow(dpy,win);
	 }
	while(done==0);
 }
